package computercraftsc.client.gui.widgets;

import computercraftsc.client.gui.KeyCodes;

public class WidgetPopup extends WidgetPanel {
	
	private WidgetContainer content;
	
	public WidgetPopup(int x, int y, int contentWidth, int contentHeight) {
		super(x, y, contentWidth + 6, contentHeight + 10);
		this.content = new WidgetContainer(3, 7, contentWidth, contentHeight);
		this.addWidget(this.content);
	}
	
	public WidgetContainer getContent() {
		return this.content;
	}
	
	public void resizeContent(int w, int h) {
		this.resize(w + 6, h + 10);
	}
	
	@Override
	public boolean mousePressed(int mouseX, int mouseY, int mouseButton) {
		boolean handled = super.mousePressed(mouseX, mouseY, mouseButton);
		if(mouseX < 0 || mouseX >= this.getWidth() || mouseY < 0 || mouseY >= this.getHeight()) {
			this.onCancel();
			return true;
		}
		return handled;
	}
	
	@Override
	public boolean keyPressed(int keyCode, int scanCode, int modifiers) {
		if(keyCode == KeyCodes.ESCAPE) {
			this.onCancel();
		} else if(keyCode == KeyCodes.RETURN || keyCode == KeyCodes.NUM_RETURN) {
			this.onConfirm();
		} else {
			super.keyPressed(keyCode, scanCode, modifiers);
		}
		return true; // Consume all key presses to prevent triggering hotkeys in the main screen.
	}
	
	@Override
	public void resize(int w, int h) {
		super.resize(w, h);
		this.content.resize(w - 6, h - 10);
	}
	
	protected void onCancel() {
	}
	
	protected void onConfirm() {
	}
}
