package computercraftsc.shared.turtle.core.code;

import net.minecraft.util.text.IFormattableTextComponent;
import net.minecraft.util.text.StringTextComponent;

/**
 * This exception can be thrown when a error occurs while executing turtle code.
 * @author P.J.S. Kools
 */
@SuppressWarnings("serial")
public class ExecutionException extends Exception {
	
	private IFormattableTextComponent textComponent = null;
	
	public ExecutionException() {
		super();
	}
	
	public ExecutionException(String message) {
		super(message);
	}
	
	public ExecutionException(IFormattableTextComponent textComponent) {
		super(textComponent.toString());
		this.textComponent = textComponent;
	}
	
	public ExecutionException(String message, Throwable cause) {
		super(message, cause);
		this.textComponent = new StringTextComponent(message);
	}
	
	public ExecutionException(Throwable cause) {
		super(cause);
	}
	
	public IFormattableTextComponent getTextComponent() {
		return (this.textComponent != null
				? this.textComponent
				: new StringTextComponent((this.getMessage() == null ? "null" : this.getMessage())));
	}
}
