package computercraftsc.shared.turtle.core.code.ast;

import java.util.List;

import computercraftsc.shared.turtle.core.code.compiler.exception.CompileException;
import computercraftsc.shared.turtle.core.code.type.ClassType;

public class BooleanConstant extends Expression {
	
	public boolean value;
	
	public BooleanConstant(int codeIndex, boolean value) {
		super(codeIndex, codeIndex);
		this.value = value;
	}
	
	@Override
	public String toCodeString() {
		return (this.value ? "true" : "false");
	}
	
	@Override
	public ClassType typecheck(List<CompileException> compileExceptions) {
		return ClassType.BOOLEAN;
	}
}
