package computercraftsc.shared.turtle.core.code.ast;

import java.util.List;

import computercraftsc.shared.turtle.core.code.compiler.exception.CompileException;
import computercraftsc.shared.turtle.core.code.type.ClassType;

public class CommentStatement extends Statement {
	
	public String comment;
	
	public CommentStatement(int codeIndex, String comment) {
		super(codeIndex, codeIndex);
		this.comment = comment;
	}
	
	@Override
	public String toCodeString() {
		return "/* " + this.comment + " */";
	}
	
	@Override
	public ClassType typecheck(List<CompileException> compileExceptions) {
		return ClassType.VOID;
	}
}
