package computercraftsc.shared.turtle.core.code.ast;

import java.util.List;

import computercraftsc.shared.turtle.core.code.compiler.exception.CompileException;
import computercraftsc.shared.turtle.core.code.type.ClassType;

public class UnaryExpression extends Expression {
	
	public UnaryOperator operator;
	public Expression exp;
	
	public UnaryExpression(int codeStartIndex, int codeEndIndex, UnaryOperator operator, Expression exp) {
		super(codeStartIndex, codeEndIndex);
		this.operator = operator;
		this.exp = exp;
	}
	
	@Override
	public String toCodeString() {
		return this.operator.getRepresentation() + this.exp.toCodeString();
	}
	
	@Override
	public ClassType typecheck(List<CompileException> compileExceptions) {
		this.requireType(this.exp, this.operator.getArgType(), compileExceptions);
		return this.operator.getReturnType();
	}
}
