package computercraftsc.shared.turtle.core.code.ast;

import computercraftsc.shared.turtle.core.code.type.ClassType;

public enum UnaryOperator {
	NOT("!", ClassType.BOOLEAN, ClassType.BOOLEAN),
	NEGATIVE("-", ClassType.INT, ClassType.INT),
	POSITIVE("+", ClassType.INT, ClassType.INT);
	
	private final String representation;
	private final ClassType argType;
	private final ClassType returnType;
	
	private UnaryOperator(String representation, ClassType argType, ClassType returnType) {
		this.representation = representation;
		this.argType = argType;
		this.returnType = returnType;
	}
	
	public String getRepresentation() {
		return this.representation;
	}
	
	public ClassType getArgType() {
		return this.argType;
	}
	
	public ClassType getReturnType() {
		return this.returnType;
	}
}
